var crypto = require('crypto'),
		dgram = require("dgram"),
		parser = require('xml2json'),
		http = require('http'),
		server = dgram.createSocket("udp4"),
		challenge = "]>2Y<iN79;m2PXDd)Az#gr6TWa/48c3Gb^ML4sBo*t8}jUqVRv",
		signature = crypto.createHash('md5').update(challenge + 'b0xeeRem0tE!').digest("hex"),
		request = new Buffer('<?xml version="1.0"?><BDP1 cmd="discover" application="iphone_remote" version="0.0.1" challenge="' + challenge + '" signature="' + signature + '"/>'),
		call = function (host, port, command, callback) {
			http.get({host: host, port: port, path: '/xbmcCmds/xbmcHttp?command=' + command}, function(res) {
				var data = '';
				res.on('data', function (chunk) {
					data += chunk;
			  });
				res.on('end', function () {
						callback(null, data);
			  });
			}).on('error', function(e) {
					callback(e, null);
			});
		};

module.exports = {
	find: function (timeout, callback) {	
		var hosts = [];

		server.on('message', function(msg) {
			msg = JSON.parse(parser.toJson(msg.toString()));
			var host = {
				'host': '',
				'port': 0
			};
			
			host['host'] = msg['BDP1'].name;
			host['port'] = msg['BDP1'].httpPort;
			hosts.push(host);
		});
		
		server.bind(41234);
		server.setBroadcast(true);
		server.send(request, 0, request.length, 2562, '0.0.0.0');
		
		setTimeout(function() {
			server.close();
			callback(hosts);
		}, timeout);
	},
	//GetVolume Retrieves the current volume setting as a percentage of the maximum possible value.
	GetVolume: function (host, callback) {
		call(host['host'], host['port'], 'GetVolume', function(e, result) {
			callback(e, result.replace(/[^\d.]/g, ''));
		});
	},
	//SetVolume(percent) Sets the volume as a percentage of the maximum possible.
	SetVolume: function (host, volume, callback) {
		call(host['host'], host['port'], 'SetVolume(' + volume + ')', function(e, result) {
			if(e && callback) {
				callback(false);
			} else if(result.replace(/<[^<>]*?>/g, '').match("OK") && callback) {
				callback(true);
			}
		});
	},
	//Mute Toggles the sound on/off.
	Mute: function (host, callback) {
		call(host['host'], host['port'], 'Mute', function(e, result) {
			if(e && callback) {
				callback(false);
			} else if(result.replace(/<[^<>]*?>/g, '').match("OK") && callback) {
				callback(true);
			}
		});
	},
	//Pause Pauses the currently playing media.
	Pause: function (host, callback) {
		call(host['host'], host['port'], 'Pause', function(e, result) {
			if(e && callback) {
				callback(false);
			} else if(result.replace(/<[^<>]*?>/g, '').match("OK") && callback) {
				callback(true);
			}
		});
	},
	//Stop Stops the currently playing media.
	Stop: function (host, callback) {
		call(host['host'], host['port'], 'Stop', function(e, result) {
			if(e && callback) {
				callback(false);
			} else if(result.replace(/<[^<>]*?>/g, '').match("OK") && callback) {
				callback(true);
			}
		});
	},
	//PlayNext Starts playing/showing the next media/image in the current playlist or, if currently showing a slidshow, the slideshow playlist.
	PlayNext: function (host, callback) {
		call(host['host'], host['port'], 'PlayNext', function(e, result) {
			if(e && callback) {
				callback(false);
			} else if(result.replace(/<[^<>]*?>/g, '').match("OK") && callback) {
				callback(true);
			}
		});
	},
	//PlayPrev Starts playing/showing the previous media/image in the current playlist or, if currently showing a slidshow, the slideshow playlist.
	PlayPrev: function (host, callback) {
		call(host['host'], host['port'], 'PlayPrev', function(e, result) {
			if(e && callback) {
				callback(false);
			} else if(result.replace(/<[^<>]*?>/g, '').match("OK") && callback) {
				callback(true);
			}
		});
	},
	//SeekPercentage(percent) Sets the playing position of the currently playing media as a percentage of the medias length.
	SeekPercentage: function (host, percent, callback) {
		call(host['host'], host['port'], 'SeekPercentage(' + percent + ')', function(e, result) {
			if(e && callback) {
				callback(false);
			} else if(result.replace(/<[^<>]*?>/g, '').match("OK") && callback) {
				callback(true);
			}
		});
	},
	//SeekPercentageRelative(relative-percentage) Adds/Subtracts the current percentage on to the current postion in the song
	SeekPercentageRelative: function (host, percent, callback) {
		call(host['host'], host['port'], 'SeekPercentageRelative(' + percent + ')', function(e, result) {
			if(e && callback) {
				callback(false);
			} else if(result.replace(/<[^<>]*?>/g, '').match("OK") && callback) {
				callback(true);
			}
		});
	},
	//GetPercentage Retrieves the current playing position of the currently playing media as a percentage of the medias length.
	GetPercentage: function (host, callback) {
		call(host['host'], host['port'], 'GetPercentage', function(e, percentage) {
			if(e && callback) {
				callback(e);
			} else if(callback) {
				percentage = percentage.replace(/<[^<>]*?>/g, '').match(/\d+/)[0];
				callback(percentage);
			}
		});
	},
	//SendKey(251) Click on HOME button
	Home: function (host, callback) {
		call(host['host'], host['port'], 'SendKey(251)', function(e, result) {
			if(e && callback) {
				callback(false);
			} else if(result.replace(/<[^<>]*?>/g, '').match("OK") && callback) {
				callback(true);
			}
		});
	},
	//SendKey(252) Click on TV button
	TV: function (host, callback) {
		call(host['host'], host['port'], 'SendKey(252)', function(e, result) {
			if(e && callback) {
				callback(false);
			} else if(result.replace(/<[^<>]*?>/g, '').match("OK") && callback) {
				callback(true);
			}
		});
	},
	//SendKey(252) Click on TV button
	Music: function (host, callback) {
		call(host['host'], host['port'], 'SendKey(253)', function(e, result) {
			if(e && callback) {
				callback(false);
			} else if(result.replace(/<[^<>]*?>/g, '').match("OK") && callback) {
				callback(true);
			}
		});
	},
	//SendKey(252) Click on TV button
	Photos: function (host, callback) {
		call(host['host'], host['port'], 'SendKey(254)', function(e, result) {
			if(e && callback) {
				callback(false);
			} else if(result.replace(/<[^<>]*?>/g, '').match("OK") && callback) {
				callback(true);
			}
		});
	},
	//SendKey(256) Click on ENTER button
	Enter: function (host, callback) {
		call(host['host'], host['port'], 'SendKey(256)', function(e, result) {
			if(e && callback) {
				callback(false);
			} else if(result.replace(/<[^<>]*?>/g, '').match("OK") && callback) {
				callback(true);
			}
		});
	},
	//SendKey(270) Click on UP button
	Up: function (host, callback) {
		call(host['host'], host['port'], 'SendKey(270)', function(e, result) {
			if(e && callback) {
				callback(false);
			} else if(result.replace(/<[^<>]*?>/g, '').match("OK") && callback) {
				callback(true);
			}
		});
	},
	//SendKey(271) Click on DOWN button
	Down: function (host, callback) {
		call(host['host'], host['port'], 'SendKey(271)', function(e, result) {
			if(e && callback) {
				callback(false);
			} else if(result.replace(/<[^<>]*?>/g, '').match("OK") && callback) {
				callback(true);
			}
		});
	},
	//SendKey(272) Click on LEFT button
	Left: function (host, callback) {
		call(host['host'], host['port'], 'SendKey(272)', function(e, result) {
			if(e && callback) {
				callback(false);
			} else if(result.replace(/<[^<>]*?>/g, '').match("OK") && callback) {
				callback(true);
			}
		});
	},
	//SendKey(273) Click on RIGHT button
	Right: function (host, callback) {
		call(host['host'], host['port'], 'SendKey(273)', function(e, result) {
			if(e && callback) {
				callback(false);
			} else if(result.replace(/<[^<>]*?>/g, '').match("OK") && callback) {
				callback(true);
			}
		});
	},
	//SendKey(275) Click on BACK button 248 + 13
	Back: function (host, callback) {
		call(host['host'], host['port'], 'SendKey(275)', function(e, result) {
			if(e && callback) {
				callback(false);
			} else if(result.replace(/<[^<>]*?>/g, '').match("OK") && callback) {
				callback(true);
			}
		});
	},
	//SendKey(61704) Sends an backspace key (used in keyboard)
	Backspace: function (host, callback) {
		call(host['host'], host['port'], 'SendKey(61704)', function(e, result) {
			if(e && callback) {
				callback(false);
			} else if(result.replace(/<[^<>]*?>/g, '').match("OK") && callback) {
				callback(true);
			}
		});
	},
	//SendKey(<ASCII value + 61696>) Sends an ASCII key (used in keyboard)
	SendKey: function (host, key, callback) {
		console.log(key);
		call(host['host'], host['port'], 'SendKey(' + (key + 61696) + ')', function(e, result) {
			if(e && callback) {
				callback(false);
			} else if(result.replace(/<[^<>]*?>/g, '').match("OK") && callback) {
				callback(true);
			}
		});
	},
	//getKeyboardText Returns whether a virtual keyboard is active, whether it has hidden text and the actual text in the keyboard.
	getKeyboardText: function (host, callback) {
		call(host['host'], host['port'], 'getKeyboardText', function(e, text) {
			if(e && callback) {
				callback(e);
			} else if(callback) {
				text = text.replace(/<[^<>]*?>/g, '').replace('\n');
				callback(text);
			}
		});
	}
}